<?php

class Controller {

	private $lib;
	private $ext;
	private $default_url;
	private $meta;

	private function set_url() {
		global $def;
		$url = $def['url'];
		$url = preg_split("/\?/", $url);
		$url = $url[0];
		$url = explode('/', $url);
		$url = array_pop($url);
		if (!$url) $url = $this->default_url;
		
		$re = preg_quote($def['ext'], '/');
		$subj = preg_replace("/{$re}$/", '', $url);
		$def['file'] = $url;
		$def['subj'] = $subj;
	}
	
	public function __construct() {
		global $def;
		$this->lib = $def['lib'];
		$this->ext = $def['ext'];
		$this->default_url = 'friends' . $def['ext'];
		$this->set_url();
		$this->invoke();
	}

	public function invoke() {
		global $def;
		$meta = $def['meta'];
		if (!isset($meta[$def['subj']])) exit(def_404());
		
		$class = 'Table';
		if (isset($_GET['id'])) {
			$class = 'Item';
			$def['id'] = intval($_GET['id']);
		}
		include $this->lib . '/view/' . $class . '.php';
		
		new $class();
	}
}