<?php

class Data extends Model {
	
	private $data;
	
	public function __construct() {
		
		$this->Model();
		
		$this->data = array(
			'people' => array(
				1 => array('id' => 1, 'name' => "Александр", 'year' => "1985", 'descr' => "Лучший друг", 'email' => "alex@mail.com", 'rel' => "friends"),
				2 => array('id' => 2, 'name' => "Юрий", 'year' => "1987", 'descr' => "Друг средней степени", 'email' => "yury@gmail.com", 'rel' => "friends"),
				3 => array('id' => 3, 'name' => "Алексей", 'year' => "1989", 'descr' => "Очень сомнительный друг: может занять максимум 2-3 тысячи р.", 'email' => "alexey@yahoo.com", 'rel' => "friends"),
				4 => array('id' => 4, 'name' => "Джо", 'year' => "1909", 'descr' => "Somebody", 'email' => "joe@yahoo.com", 'rel' => "enemies"),
				5 => array('id' => 5, 'name' => "Джесси", 'year' => "1919", 'descr' => "Ведьма", 'email' => "jessie@yahoo.com", 'rel' => "enemies"),
			),
			'cats' => array(
				1 => array('id' => 1, 'name' => "Вася", 'year' => "1993", 'descr' => "Очень лохматый и чёрный"),
			),
			'jobs' => array(
			),
		);
		
		$this->data = $this->set_data();
	}
	
	public function set_data() {
		
		global $def;
		$meta = $def['meta'][$def['subj']];
		$table = $meta['table'];
		$def['sql_table'] = $table;
		$table = $this->data[$table];
		
		if (empty($meta['flag'])) return $table;
		$flag = $meta['flag'];
		$flag_value = $def['subj'];
		
		$arr = array();
		foreach ($table as $key => $row) {
			if ($row[$flag] == $flag_value) $arr[$key] = $row;
		}
		return (count($arr)) ? $arr : def_404();
	}
	
	public function get_item() {
		global $def;
		$table = $def['sql_table'];
		$meta = $def['meta'][$def['subj']];
		$title = $meta['title'];
		$id = $def['id'];
		
		$fields = $this->fields[$table];
		$data = esse($this->data, $id);
		if (empty($data)) return def_404();
		$item = $this->get_row($fields, $data);
		
		return array('item' => $item, 'title' => $title . ': ' . $item['name'][0]);
	}
	
	public function get_table() {
		global $def;
		$table = $def['sql_table'];
		$meta = $def['meta'][$def['subj']];
		$title = $meta['title'];
		
		$fields = $this->fields[$table];
		$data = $this->data;
		$thead = array();
		$tbody = array();
		
		foreach ($fields as $field => $prop) {
			if (empty($prop['list'])) continue;
			$thead[$field] = $prop;
		}
		
		foreach ($data as $key => $value) {
			$tbody[] = $this->get_row($thead, $value, $def['subj']);
		}
		
		return array('caption' => $title, 'thead' => $thead, 'tbody' => $tbody, 'title' => $title);
	}
	
	public function get_row(&$arr, &$data, $subj = false) {
		$row = array();
		foreach ($arr as $field => $prop) {
			if (!empty($prop['ru'])) {
				$extra = ($subj) ? false : $prop['ru'];
				$tpl = false;
				
				if (!empty($prop['link']) && $subj) {
					$extra = $subj . '?id=' . $data[$prop['link']];
					$tpl = 'a';
				}
				$row[$field] = array($data[$field], $extra, $tpl);
			}
		}
		return $row;
	}
	
	public function get_menu() {
		global $def; 
		$meta = $def['meta'];
		//$labels = $this->labels;
		$menu = array();
		foreach ($meta as $subj => $arr) {
			$file = $subj . $def['ext'];
			if ($file == $def['file']) $file = false;
			
			if ($arr['count']) //наличие данных
				$menu[] = array('href' => $file, 'text' => $arr['title']);
		}
		
		return $menu;
	}
	
	
}
