<?php

class Table  extends View {

	private $table;
	
	public function __construct() {
		$data = new Data();
		$table = $data->get_table();
		$this->table = $table;
		
		$this->View($data);
	}
	
	public function out() {
		global $def;
		$title = $this->table['title'];
		$caption = $this->table['caption'];
		$subj = $def['subj'];
		$head = $this->build_head();
		$thead = $head['thead'];
		$cols = $head['cols'];
		
		$menu = $this->build_menu();
		$tbody = $this->build_tbody();
		include $def['lib'] . '/view/' . __CLASS__ . '.tpl.php';
	}
	
	public function build_head() {
		global $def;
		$tpl = $def['templates'];
		
		$head = $this->table['thead'];
		$thead = '<tr>';
		$cols = '';
		foreach($head as $field => $prop) {
			if (!empty($prop[$def['show']])) {
				$thead .= printf_e($tpl['th'], $field, $prop[$def['show']]);
				$cols .= printf_e($tpl['col'], $field);
			}
		}
		$thead .= '</tr>';
		return array('thead' => $thead, 'cols' => $cols);
	}
	
	public function build_tbody() {
		global $def;
		$tpl = $def['templates'];
		
		$thead = $this->table['thead'];
		$tbody = $this->table['tbody'];
		$str = '';
		//print_r($tbody);
		foreach($tbody as $row) {
			//print_r($value); exit;
			$str .= '<tr>';
			foreach($thead as $field => $prop) {
				if (!empty($prop[$def['show']])) {
					$value = $row[$field];
					$html = (!empty($value[2])) 
					? printf_e($tpl[$value[2]], $value[1], $value[0]) 
					: def_e($value[0]);
					$str .= sprintf($tpl['td'], $html);
				}
			}
			$str .= '</tr>';
		}
		
		return $str;
	}
	
}